---
- name: Query source SRC_L3_ID
  command: >
    {{ neutron_drain_venv }}/bin/openstack
    network agent list --host {{ neutron_drain_host }}
    --agent-type l3 -f value -c ID
  register: SRC_L3_ID
  environment: "{{ openstack_auth_env }}"
  delegate_to: "{{ neutron_drain_host }}"
  vars:
    ansible_host: "{{ hostvars[neutron_drain_host].ansible_host }}"

- name: Set fact containing SRC_L3_ID
  set_fact:
    L3_SRC_ID: "{{ SRC_L3_ID.stdout }}"

- name: Enable L3 agent
  command: >
    {{ neutron_drain_venv }}/bin/openstack
    network agent set "{{ L3_SRC_ID }}" --enable
  environment: "{{ openstack_auth_env }}"
  delegate_to: "{{ neutron_drain_host }}"
  vars:
    ansible_host: "{{ hostvars[neutron_drain_host].ansible_host }}"

- name: Get Router IDs
  command: >
    {{ neutron_drain_venv }}/bin/openstack
    router list -f value -c ID
  register: router_ids
  environment: "{{ openstack_auth_env }}"
  delegate_to: "{{ neutron_drain_host }}"
  vars:
    ansible_host: "{{ hostvars[neutron_drain_host].ansible_host }}"

- name: Set Router IDS
  set_fact:
    ROUTER_IDS: "{{ router_ids.stdout_lines }}"

- name: Add router
  command: >
    {{ neutron_drain_venv }}/bin/openstack
    network agent add router {{ L3_SRC_ID }} {{ item }} --l3
  environment: "{{ openstack_auth_env }}"
  delegate_to: "{{ neutron_drain_host }}"
  vars:
    ansible_host: "{{ hostvars[neutron_drain_host].ansible_host }}"
  with_items:
    - "{{ ROUTER_IDS }}"
  loop_control:
    pause: 10
